package com.tidecloud.dataacceptance.common;

import java.nio.charset.Charset;

/**   
 * @author: chudk 
 * @date:   2017年11月8日 上午11:00:24   
 */
public class Constants {
    
    public static final String GBK_ENCODING = "GBK";
    public static final Charset GBK_CHARSET = Charset.forName(GBK_ENCODING);
    
    //flag bit
    public static final Byte PKG_DELIMITER = 0x7e;
    //client 15 minute no link, server brokening link
    public static Integer TCP_CLIENT_IDLE_MINUTES = 30;
    
    //terminal general copy id
    public static final Integer MSG_TERMINAL_COMMON_RESP_ID = 0x00001;
    //terminal hearbeat id
    public static final Integer MSG_TERMINAL_HEART_BEAT_ID = 0x0002;
    //terminal register id
    public static final Integer MSG_TERMINAL_REGISTER = 0x0100;
    //terminal logout id
    public static final Integer MSG_TERMINAL_LOG_OUT = 0x0003;
    //terminal authentification id
    public static final Integer MSG_TERMINAL_AUTHENTIFICATION_ID = 0x0102;
    //terminal customize location info upload id 
    public static final Integer MSG_TERMINAL_CUSTOMIZE_LOCATION_INFO_UPLOAD = 0x0900;
    //terminal location info upload id 
    public static final Integer MSG_TERMINAL_LOCATION_INFO_UPLOAD = 0x0200;
    //terminal tire pressure id
    public static final Integer MSG_TERMINAL_TIRE_PRESSURE_ID = 0x0600;
    //query terminal param copy id
    public static final Integer MSG_TERMINAL_PARAM_QUERY_COPY = 0x0104;
    //car control reply
    public static final Integer MSG_TERMINAL_CAR_CONTROL_REPLY = 0x0500;
    
    //server general copy id
    public static final Integer SERVER_COMMON_RESP_ID = 0x8001;
  //server general copy id
    public static final Integer SERVER_8900_RESP_ID = 0x8900;
    //server copy terminal register id
    public static final Integer SERVER_REGISTER_RESP_ID = 0x8100;
    //set terminal param
    public static final Integer SERVER_SET_PARAM_ID = 0x8103;
    //set terminal query param
    public static final Integer SERVER_SET_QUERY_PARAM = 0x8104;


    //type of time data
    public static final Integer TYPE_OF_TIME = 0;
    //type of gps data
    public static final Integer TYPE_OF_CAN_DATA = 1;
    public static final Integer TYPE_OF_GPS = 5;
    public static final Integer TYPE_OF_SWT = 2;
    public static final Integer TYPE_OF_EXT = 3;
    public static final Integer TYPE_OF_AD_OIL = 4;
    public static final Integer TYPE_OF_MILEAGE = 6;
    public static final Integer TYPE_OF_SPEED = 7;
    public static final Integer TYPE_OF_DRIVER_DATA = 8;
    
    //Can - sub - type
    public static final Integer SUB_TYPE_OF_TURNSPEED = 0x01;
    public static final Integer SUB_TYPE_OF_TORQUE = 0x02;
    public static final Integer SUB_TYPE_OF_VOLTAGE = 0x03;
    public static final Integer SUB_TYPE_OF_OILTEMPERTURE = 0x04;
    public static final Integer SUB_TYPE_OF_ENGINEOILPRESSURE = 0x05;
    public static final Integer SUB_TYPE_OF_AIRPRESSURE = 0x06;
    public static final Integer SUB_TYPE_OF_AIRINTEMPERTURE = 0x07;
    public static final Integer SUB_TYPE_OF_CANSPEED = 0x08;
    public static final Integer SUB_TYPE_OF_COOLANTTEMPERTURE = 0x09;
    public static final Integer SUB_TYPE_OF_OIL = 0x0A;
    public static final Integer SUB_TYPE_OF_RUNTIME = 0x0B;
    public static final Integer SUB_TYPE_OF_DM1FAULTCODE = 0x0C;
    public static final Integer SUB_TYPE_OF_TRANSIENTOIL = 0x0D;
    
    public static class LocationPackage{
        public static final Integer TYPE_OF_MILEAGE = 0x01;
        public static final Integer TYPE_OF_OIL = 0x02;
        public static final Integer TYPE_OF_SPEED = 0x03;
        public static final Integer TYPE_OF_WARN_ID = 0x04;
        
        public static final Integer TYPE_OF_TURNOVER_WARN = 0x12;
        public static final Integer TYPE_OF_RUN_WARN = 0x13;
        public static final Integer TYPE_OF_ADDITIONAL_STATE = 0x25;
        public static final Integer TYPE_OF_IO_STATE = 0x2A;
        public static final Integer TYPE_OF_SIMULATION = 0x2B;
        public static final Integer TYPE_OF_SIGNAL_STRENGTH = 0x30;
        public static final Integer TYPE_OF_SATELLITE = 0x31;
        public static final Integer TYPE_OF_CUSTOM = 0xEB;
        
        //网锐位置附加扩展指令
        public static final Integer TYPE_OF_CUSTOM_WAGNRUI = 0xFC;
        public static final Integer TYPE_OF_CUSTOM_0XFC_0X01 = 0x01;
        public static final Integer TYPE_OF_CUSTOM_0XFC_0X02 = 0x02;
        public static final Integer TYPE_OF_CUSTOM_0XFC_0X03 = 0x03;
        public static final Integer TYPE_OF_CUSTOM_0XFC_0X04 = 0x04;
        public static final Integer TYPE_OF_CUSTOM_0XFC_0X05 = 0x05;
      
        public static final Integer LENGTH_OF_OIL = 0x0008;
        public static final Byte POINT = 0x2e;
    }
}

